<template>
  <no-ssr>
    <div class="kd933-chart">
      <Icon v-if="lockP5Drawing" class="p5-lock" type="md-lock" />
      <nuxt-p5 :id="domId"
               :width="width"
               :height="height"
               @size="sizeAction" v-on="script">
      </nuxt-p5>
    </div>
  </no-ssr>
</template>

<script>
  import NuxtP5 from './NuxtP5';
  import { script, actions, emits, events, functions, baseConfig } from '../../helpers/p5';

  const p5Events = {
    ...events,
    _draw(sketch) {
      if (!this.lockP5Drawing) {
        this.sketch = sketch;
        this.drawBackground(sketch);
        this.drawCoordinateSystem(sketch);
        this.drawDataPointCurve(sketch);
        this.drawCrossHair(sketch);
      }
    },
  };

  const p5Functions = {
    ...functions,
  };

  export default {
    name: "StockKd933LineChart",
    mixins: [baseConfig],
    components: { NuxtP5 },
    props: {
      drawCurve: { type: Array, default: () => { return ['ks933', 'ds933']; }},
    },
    data() {
      return {
        domId: `kd-chart-${(new Date()).getTime().toString()}`,
        script: script(this),
        canvas: {
          coordinate: {
            step: 0.01,
            longMarkStep: 10,
            shortMarkStep: 5,
          },
          crossHair: { width: 65, height: 30, fractionDigits: 2 },
        },
        dataFields: [
          { dataField: 'ks933', label: 'K', color: '#43a949' },
          { dataField: 'ds933', label: 'D', color: '#ad5fff' },
        ],
        fieldToShow: ['ks933', 'ds933'],
      };
    },
    computed: {},
    watch: {},
    methods: {
      ...actions,
      ...emits,
      ...p5Events,
      ...p5Functions,
    },
    mounted() {},
  }
</script>

<style scoped>

</style>
